' ========================================================================================
' GdipSetPropertyItem
' ========================================================================================

' ========================================================================================
' The following console application creates a Image object based on a JPEG file. The code
' calls the GdipSetPropertyItem function of that Image object to set the title of the
' image. Then the code retrieves and displays the new title.
' ========================================================================================

' SED_PBCC
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"
#INCLUDE "GDIPUTILS.INC"

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL hStatus AS LONG
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput
   LOCAL pImage AS DWORD
   LOCAL strFileName AS STRING
   LOCAL propItem AS PropertyItem
   LOCAL szNewTitleValue AS ASCIIZ * 256
   LOCAL nSize AS DWORD
   LOCAL buffer AS STRING
   LOCAL pvAsciiz AS ASCIIZ PTR
   LOCAL EncoderClsid AS GUID

   ' // Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hStatus = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hStatus THEN
      PRINT "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   strFileName = UCODE$("BERRY_Halle.jpg")
   hStatus = GdipLoadImageFromFile(STRPTR(strFileName), pImage)

   szNewTitleValue = "Halle Berry"
   propItem.id = %PropertyTagImageTitle
   propItem.length = LEN(szNewTitleValue) + 1  ' // Includes null terminator
   propItem.type = %PropertyTagTypeASCII
   propItem.value = VARPTR(szNewTitleValue)
   hStatus = GdipSetPropertyItem(pImage, propItem)

   ' // GEt and display the new image title
   RESET propItem
   hStatus = GdipGetPropertyItemSize(pImage, %PropertyTagImageTitle, nSize)
   buffer = SPACE$(nSize)
   hStatus = GdipGetPropertyItem(pImage, %PropertyTagImageTitle, nSize, BYVAL STRPTR(buffer))
   LSET propItem = buffer
   IF propItem.value THEN
      pvAsciiz = propItem.value
      PRINT "New title: " & @pvAsciiz
   END IF

   ' // Get the CLSID of the PNG encoder.
   EncoderClsid = GUID$(GdiPlusGetEncoderClsid("image/jpeg"))

   ' // Save the image with another name.
   strFileName = UCODE$("BERRY_Halle_Modified.jpg")
   hStatus = GdipSaveImageToFile(pImage, STRPTR(strFileName), EncoderClsid, BYVAL %NULL)
   IF hStatus = %StatusOk THEN
      PRINT "BERRY_Halle_Modified.jpg saved successfully"
   ELSE
      PRINT "Attempt to save BERRY_Halle_Modified.jpg failed"
   END IF

   ' // Cleanup
   IF pImage THEN GdipDisposeImage(pImage)

   ' // Shutdown GDI+
   GdiplusShutdown token

   WAITKEY$

END FUNCTION
' ========================================================================================
